//*****************************************************************************
//* Copyright (c) 2011 Miday Workshop All rights reserved.
//*
//* File: ReMake.cpp
//*****************************************************************************

#include <windows.h>
#include <stdio.h>
#include <shlobj.h>
#include "Ribbon.h"
#include "resource.h"

extern bool RibbonEdit(HWND hWnd, IShellDispatch *pDispatch, wchar_t *tmp_folder, int *chkflag);

extern wchar_t Addin_path[PATH_SIZE], Toolkit_path[PATH_SIZE], Temp_path[PATH_SIZE];
static wchar_t addinfile[PATH_SIZE], addinzipfile[PATH_SIZE];
static int Stepflag1, Stepflag2;

//==============================================================================
//t@C邩ׁATCYԂ@tH_[Ȃ-1Ԃ
//==============================================================================
unsigned int FileSizeGet(wchar_t *file_name) {
//*file_name@@t@C
	HANDLE hndl;
	WIN32_FIND_DATA FindFileData;
	unsigned int len;

	hndl = FindFirstFile(file_name, &FindFileData);
//	hndl = FindFirstFileEx( file_name.c_str(),
//		FindExInfoStandard, &FindFileData, FindExSearchNameMatch, NULL, 0 );
	if ( hndl != INVALID_HANDLE_VALUE ) {
		if ( (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != FILE_ATTRIBUTE_DIRECTORY ) {
			len = FindFileData.nFileSizeLow + FindFileData.nFileSizeHigh + 32768;
			FindClose(hndl);
			return len;
		} else {
			FindClose(hndl);
			return -1;
		}
	} else {
		return 0;
	}
//	return 0;
}

//==============================================================================
//ZIPt@C쐬
//==============================================================================
static int MakeZipfile(wchar_t *filename) {
//*filename@@zipt@C
	DWORD attr;
	FILE *fp;

	BYTE heder[] = {  'P',  'K', 0x05, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	                 0x00, 0x00 };

#if !defined(_MSC_VER) || _MSC_VER < 1400
	if ( (fp = _wfopen(filename, L"wb")) == NULL ) {
#else
	if ( _wfopen_s(&fp, filename, L"wb") != 0 ) {
#endif
		fclose(fp);
		return -1;
	}
	if ( fwrite(heder, sizeof(BYTE), sizeof(heder), fp) < sizeof(heder) ) {
		fclose(fp);
		return -1;
	}
	fclose(fp);

	attr = GetFileAttributes(filename);
	attr =  attr & (-1 ^ FILE_ATTRIBUTE_READONLY);
	SetFileAttributes(filename, attr);

	return 0;
}

//==============================================================================
//tH_[폜
//==============================================================================
static int FolderDelete(HWND hWnd, const wchar_t *folder_name) {
//hWnd@@@@@@EChEnh
//*folder_name@@tH_[
//߂l@=0 
//@@@@!=0 s
	SHFILEOPSTRUCT opt;
	wchar_t work1[PATH_SIZE];
	int ia, ir;

	WCSCPY(work1, sizeof(work1), folder_name);//Ō\0\0ɂ
	ia = wcslen(work1);
	work1[ia]   = '\0';
	work1[ia+1] = '\0';

	memset(&opt, 0, sizeof(SHFILEOPSTRUCT));
	opt.hwnd  = hWnd;
	opt.wFunc = FO_DELETE;
	opt.pFrom = work1;
	opt.pTo   = NULL;
	opt.fFlags= FOF_NOCONFIRMATION;

	ir = SHFileOperation(&opt);

	return ir;
}

//==============================================================================
//tH_[Rs[
//==============================================================================
static bool FolderCopy(IShellDispatch *pDispatch, wchar_t *fromfolder_name, wchar_t *tofolder_name) {
//*pDispatch@@@@IuWFNg̃|C^
//*fromfolder_name@Rs[tH_[
//*tofolder_name@@Rs[tH_[
//߂l@TRUE  
//@@@@FALSE s
	HRESULT     hr;
	VARIANT     FromFolder, ToFolder, Item, Options;
	Folder      *pFromFolder, *pToFolder;
	FolderItems *pFromFolderItems;

	//Rs[̃tH_[IuWFNg쐬
	VariantInit(&FromFolder);
	FromFolder.vt      = VT_BSTR;
	FromFolder.bstrVal = SysAllocString(fromfolder_name);
	hr = pDispatch->NameSpace(FromFolder, &pFromFolder);
	VariantClear(&FromFolder);
	if (hr != S_OK) {
		return FALSE;
	}

	//Rs[̃tH_[IuWFNg쐬
	VariantInit(&ToFolder);
	ToFolder.vt      = VT_BSTR;
	ToFolder.bstrVal = SysAllocString(tofolder_name);
	hr = pDispatch->NameSpace(ToFolder, &pToFolder);
	VariantClear(&ToFolder);
	if (hr != S_OK) {
		pFromFolder->Release();
		return FALSE;
	}

	//Rs[ItemsRNV̎o
	hr = pFromFolder->Items(&pFromFolderItems);
	if (hr != S_OK) {
		pFromFolder->Release();
		pToFolder->Release();
		return FALSE;
	}

	//tH_[̃Rs[
	VariantInit(&Item);
	Item.vt       = VT_DISPATCH;
	Item.pdispVal = pFromFolderItems;
	VariantInit(&Options);
	Options.vt   = VT_I4;
	Options.lVal = FOF_SILENT | FOF_NOCONFIRMATION;
	hr = pToFolder->CopyHere(Item, Options);
//	hr = pToFolder->MoveHere(Item, Options);

	pFromFolderItems->Release();
	pFromFolder->Release();
	pToFolder->Release();

	if (hr != S_OK) {
		return FALSE;
	}
	return TRUE;
}

//==============================================================================
//G[bZ[W\ďI
//==============================================================================
static void ErrorEnd(HWND hWnd, wchar_t *msg) {
	if ( Stepflag1 != 0 ) {
		CoUninitialize();
	}
	if ( Stepflag2 != 0 ) {
		MoveFile(addinzipfile, addinfile);
	}
	if ( wcscmp(msg, L"") != 0 ) {
		MessageBox(hWnd, msg, WIND_TITLE, MB_ICONSTOP | MB_OK);
	}
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"G[܂");
}

//==============================================================================
//AhCҏW
//==============================================================================
int ReMake(HWND hWnd, wchar_t *ribbon_file, int *chkflag) {
	IShellDispatch *pDispatch;
	wchar_t tmp_folder[PATH_SIZE], work1[PATH_SIZE];
	int ia;

	//ϐݒ
	Stepflag1 = 0;
	Stepflag2 = 0;
	WCSCPY(addinfile, sizeof(addinfile), Addin_path);
	WCSCAT(addinfile, sizeof(addinfile), ribbon_file);

	WCSCPY(addinzipfile, sizeof(addinzipfile), addinfile);
	WCSCAT(addinzipfile, sizeof(addinzipfile), L".zip");

	WCSCPY(tmp_folder, sizeof(tmp_folder), Temp_path);
	WCSCAT(tmp_folder, sizeof(tmp_folder), WORK_FOLDER);

	CoInitialize(NULL);
	Stepflag1 = 1;

	if (CoCreateInstance(CLSID_Shell, NULL, CLSCTX_INPROC_SERVER, IID_IDispatch, (void **)&pDispatch) != S_OK) {
		ErrorEnd(hWnd, L"ҏWo܂łB");
		return -1;
	}

	//zipt@CҏW\`FbN
	if(FileSizeGet(addinfile) <= 22 )  {//22͋ZIPt@C̃TCY
		ErrorEnd(hWnd, L"w肳ꂽt@ĆAҏWo܂B");
		return -1;
	}

	//obNAbv
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"obNAbvĂ܂");
	WCSCPY(work1, sizeof(work1), Toolkit_path);
	WCSCAT(work1, sizeof(work1), ribbon_file);
	if ( CopyFile(addinfile, work1, FALSE) != TRUE ) {
		ErrorEnd(hWnd, L"obNAbvo܂łB");
		return -1;
	}
	Sleep(1000);

	//zip̊gqt@艺ł́AG[Ƀt@C߂
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"zipt@CɂĂ܂");
	if ( MoveFile(addinfile, addinzipfile) != TRUE ) {
		ErrorEnd(hWnd, L"t@CύXo܂łB");
		return -1;
	}
	Stepflag2 = 1;
	Sleep(1000);

	//ƃtH_[ɂꍇ͍폜
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"ƃtH_[쐬Ă܂");
	ia = FileSizeGet(tmp_folder);
	if ( ia > 0 ) {
		if ( DeleteFile(tmp_folder) != TRUE ) {
			ErrorEnd(hWnd, L"Ɨpt@C폜o܂łB");
			return -1;
		}
	} else if ( ia == -1 ) {
		if ( FolderDelete(hWnd, tmp_folder) != 0) {
			ErrorEnd(hWnd, L"ƗptH_[폜o܂łB");
			return -1;
		}
	}

	//ƃtH_쐬
	if ( CreateDirectory(tmp_folder, NULL) != TRUE ) {
		ErrorEnd(hWnd, L"ƗptH_[쐬o܂łB");
		return -1;
	}

	//ƃtH_ɓWJ
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"ƃtH_[ɓWJĂ܂");
	if (FolderCopy(pDispatch, addinzipfile, tmp_folder) != TRUE ) {
		ErrorEnd(hWnd, L"ƃtH_ɓWJo܂łB");
		return -1;
	}
	Sleep(1000);

	//AhC̕ҏW
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"AhCҏWĂ܂");
	if (RibbonEdit(hWnd, pDispatch, tmp_folder, chkflag) != TRUE ) {
		ErrorEnd(hWnd, L"");//G[bZ[W͊֐̒ŕ\Ă̂NULLn
		return -1;
	}

	//AhCt@C̏@@̒̓AhCt@CȂ
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"AhCĂ܂");
	if ( DeleteFile(addinzipfile) != TRUE ) {
		ErrorEnd(hWnd, L"AhCt@C폜o܂łB");
		return -1;
	}
	if (MakeZipfile(addinzipfile) != 0) {
		ErrorEnd(hWnd, L"AhCt@C쐬o܂łB");
		return -1;
	}
	Sleep(1000);

	//AhCt@CɃt@C߂
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"AhCč\zĂ܂");
	if (FolderCopy(pDispatch, tmp_folder, addinzipfile) != TRUE) {
		ErrorEnd(hWnd, L"AhCt@Cɖ߂܂łB");
		return -1;
	}
	Sleep(1000);

	//ƃtH_̍폜
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"ƃtH_폜Ă܂");
	ia = FileSizeGet(tmp_folder);
	if ( ia > 0 ) {
		if ( DeleteFile(tmp_folder) != TRUE ) {
			ErrorEnd(hWnd, L"Ɨpt@C폜o܂łB");
			return -1;
		}
	} else if ( ia == -1 ) {
		if ( FolderDelete(hWnd, tmp_folder) != 0 ) {
			ErrorEnd(hWnd, L"ƗptH_[폜o܂łB");
			return -1;
		}
	}

	//zip̊gq
	Stepflag2 = 0;
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"Ō̍Ƃ폜Ă܂");
	if ( MoveFile(addinzipfile, addinfile) != TRUE ) {
		ErrorEnd(hWnd, L"AhCt@Cɖ̕ύXo܂łB");
		return -1;
	}
	Sleep(1000);

	Stepflag1 = 0;
	CoUninitialize();

	MessageBox(hWnd, L"ƂI܂B", WIND_TITLE, MB_ICONINFORMATION | MB_OK);
	SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"I܂");

	return 0;
}
